--
-- ReckSilageSpreaderMagna
-- Specialization for ReckSilageSpreaderMagna Particlesystem & animation
--
-- @author  Stefan Maurus	
-- @date  2015/12/07

-- Copyright  Stefan Maurus, www.stefanmaurus.de


ReckSilageSpreaderMagna = {};

function ReckSilageSpreaderMagna.prerequisitesPresent(specializations)
    return true;
end;

function ReckSilageSpreaderMagna:load(xmlFile)	
    self.bunkerSiloCompactingScaleOnContact = self.bunkerSiloCompactingScale; --FahrsiloExtension

	self.distributorTurnedOnRotationNodes = Utils.loadRotationNodes(xmlFile, {}, "vehicle.turnedOnRotationNodes.turnedOnRotationNode", "distributor", self.components);
	self.distributorGroundReference = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.distributorGroundReference#index"));
	self.distributorGroundReferenceThreshold = Utils.getNoNil(getXMLString(xmlFile, "vehicle.distributorGroundReference#threshold"), 0)+0.05;
	
	self.grassParticleSystem = {};
	local ps = Utils.loadParticleSystem(xmlFile, self.grassParticleSystem, "vehicle.grassParticleSystem", self.components, false, nil, self.baseDirectory);
end;

function ReckSilageSpreaderMagna:delete()
	Utils.deleteParticleSystem(self.grassParticleSystem);
end;

function ReckSilageSpreaderMagna:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ReckSilageSpreaderMagna:keyEvent(unicode, sym, modifier, isDown)
end;

function ReckSilageSpreaderMagna:update(dt)
    if self.isClient then
		Utils.updateRotationNodes(self, self.distributorTurnedOnRotationNodes, dt, self:getIsActive() and self:getIsTurnedOn());
    end;
end;

function ReckSilageSpreaderMagna:updateTick(dt)
    if self.isClient then
		if self:getIsActive() and self:getIsTurnedOn() and (self.lastSpeed*3600) > 0.4 then
			local groundRaycastResult = {
				raycastCallback = function (self, transformId, x, y, z, distance)
					self.distance = distance;
					--[[local object = g_currentMission:getNodeObject(transformId);
					if object ~= nil then
						if object.fillLevel ~= nil and object.movingPlanes ~= nil then
							for i, v in ipairs(object.movingPlanes) do
								if v.nodeId == getParent(transformId) then
									if v.fillLevel > 0 then
										self.distance = distance;
									end;
								end;
							end;
						end;
					end;]]
				end
			};
			groundRaycastResult.distance = self.distributorGroundReferenceThreshold;

			local x, y, z = getWorldTranslation(self.distributorGroundReference);	
			raycastAll(x, y, z, 0, -1, 0, "raycastCallback", self.distributorGroundReferenceThreshold, groundRaycastResult, 8388608);
			
			if groundRaycastResult.distance < self.distributorGroundReferenceThreshold then
				Utils.setEmittingState(self.grassParticleSystem, true);
				self.bunkerSiloCompactingScale = 1;
			else
				Utils.setEmittingState(self.grassParticleSystem, false);
				self.bunkerSiloCompactingScale = 0;
			end;
		else
			Utils.setEmittingState(self.grassParticleSystem, false);
			self.bunkerSiloCompactingScale = 0;
		end;
    end;
end;

function ReckSilageSpreaderMagna:onAttach()	
end;

function ReckSilageSpreaderMagna:onDetach()		
end;

function ReckSilageSpreaderMagna:draw()
end;